package com.p2pdemo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Bundle;
import android.os.SystemClock;
import android.app.Activity;
import android.content.Context;
import android.util.Log;

import com.vveye.T2u;

public class MainActivity extends Activity {
	private final String TAG = "T2U";
	private String LocalAddr = "127.0.0.1";
	private Context mContext = this;
	private TextView logText;
	private EditText device_uuid_edit,device_port_edit,local_port_edit,
			server_addr_edit,server_port_edit,server_key_edit,t2u_pass_edit;
	private Button t2u_button;
	private ImageView scan_device;
	private Button test_local;
	private Timer checkPortStateTimer;
	private Thread createThread;
	private ProgressDialog progressDialog;

	private int p2pPort;
	private int curPortState;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		Log.d(TAG,"Demo for T2u!");
		p2pPort = 0;

		initView();
	}


	private void initView(){
		logText = (TextView) findViewById(R.id.logtext);
		device_uuid_edit = (EditText) findViewById(R.id.device_uuid);
		device_port_edit = (EditText) findViewById(R.id.device_port);
		local_port_edit = (EditText) findViewById(R.id.local_port);
		server_addr_edit = (EditText) findViewById(R.id.server_addr);
		server_port_edit = (EditText) findViewById(R.id.server_port);
		server_key_edit = (EditText) findViewById(R.id.server_key);
		t2u_pass_edit = (EditText) findViewById(R.id.t2u_pass);

		t2u_button = (Button)findViewById(R.id.p2p_button);
		scan_device = (ImageView)findViewById(R.id.scan_device);
		test_local = (Button)findViewById(R.id.test_localport);

		t2u_button.setOnClickListener(onClickListener);
		scan_device.setOnClickListener(onClickListener);
		test_local.setOnClickListener(onClickListener);
		test_local.setVisibility(View.GONE);
	}

	private OnClickListener onClickListener = new OnClickListener() {
		@Override
		public void onClick(View view) {
			switch (view.getId()){
				case R.id.p2p_button:
					Log.e("DEBUG",T2u.Status()+"");
					if(T2u.Status()==1){
						//stop
						closeP2PTunnel();
					}else{
						//start
						createP2PTunnel();
					}
					break;
				case R.id.scan_device:
					Thread scanThread = new Thread(new Runnable() {
						@Override
						public void run() {
							runOnUiThread(new Runnable() {
								@Override
								public void run() {
									progressDialog = new ProgressDialog(mContext);
									progressDialog.setTitle("scan device..");
									progressDialog.setCanceledOnTouchOutside(false);
									progressDialog.show();
								}
							});

							byte[] result = new byte[1500];
							int num = T2u.Search(result);
							String tmp;
							Log.e("T2u","T2u.Search:"+num);
							if (num>0)
							{
								tmp = new String(result).trim();
								String temps[] = tmp.split("\n");
								for(int i=0;i<temps.length;i++){
									temps[i] = temps[i].substring(temps[i].indexOf("=")+1,temps[i].indexOf(","));
									Log.e(TAG,temps[i]);
								}
								final String uuids[] = temps;
								runOnUiThread(new Runnable() {
									@Override
									public void run() {
										new AlertDialog.Builder(mContext)
												.setTitle("Device List")
												.setItems(uuids, new DialogInterface.OnClickListener() {
													@Override
													public void onClick(DialogInterface dialogInterface, int i) {
														device_uuid_edit.setText(uuids[i]);
													}
												})
												.setNegativeButton("Cancel", null)
												.show();
									}
								});

							}
							runOnUiThread(new Runnable() {
								@Override
								public void run() {
									progressDialog.dismiss();
								}
							});
						}
					});
					scanThread.start();
					break;
				case R.id.test_localport:
					Uri uri = Uri.parse("http://127.0.0.1:"+p2pPort);
					Intent intent = new Intent(Intent.ACTION_VIEW,uri);
					startActivity(intent);
					break;

			}
		}
	};

	private void createP2PTunnel(){
		final String device_uuid = device_uuid_edit.getText().toString().trim();
		final String device_port = device_port_edit.getText().toString().trim();
		final String local_port = local_port_edit.getText().toString().trim();
		final String server_addr = server_addr_edit.getText().toString().trim();
		final String server_port = server_port_edit.getText().toString().trim();
		final String server_key = server_key_edit.getText().toString().trim();
		final String t2u_pass = t2u_pass_edit.getText().toString().trim();

		if(device_uuid.length()==0){
			Toast.makeText(mContext,"Please input UUID!",Toast.LENGTH_SHORT).show();
			return;
		}
		if(createThread!=null&&createThread.isAlive()){
			return;
		}
		createThread = new Thread(new Runnable() {
			@Override
			public void run() {
				int retryCount = 0;
				setT2uButtonState(1);
				T2u.Init(server_addr, (char)Integer.parseInt(server_port), server_key);
				while(T2u.Status()!=1)
				{
					addLogText("Connecting to the server ... ");
					SystemClock.sleep(1000);
					Log.d(TAG,"T2u.Status="+T2u.Status());
					retryCount++;
					if(retryCount>10){
						addLogText("Connect timeout! ");
						T2u.Exit();
						setT2uButtonState(0);
						return;
					}
				}
				addLogText("Connecting success ");
				int devicesState = T2u.Query(device_uuid);
				if(devicesState==0){
					addLogText("device offline! ");
					T2u.Exit();
					setT2uButtonState(0);
					return;
				}else if(devicesState==1){
					addLogText("device online! ");
				}


				p2pPort = T2u.AddPortV3(device_uuid, t2u_pass,LocalAddr ,
						(char)Integer.parseInt(device_port), (char)Integer.parseInt(local_port));

				if(p2pPort==-1){
					addLogText("Port conflicts! Please change the local port.");
					T2u.Exit();
					setT2uButtonState(0);
					return;
				}else{
					addLogText("AddPort -> "+p2pPort);
					retryCount = 0;
					while(true) {
						//int portStatus = T2u.PortStatus((char) p2pPort);
						byte[] jsonByte = new byte[1024];
						int portStatus = T2u.PortStatusEx((char) p2pPort,jsonByte,jsonByte.length);
						//Log.e("DEBUG","portStatus "+portStatus+"   "+new String(jsonByte).trim());

						String textString = "PortStatus->:" + portStatus;
						addLogText(textString);
						if (portStatus==1){
							addLogText("create P2P Tunnel success.");
							addLogText(new String(jsonByte).trim());
							setT2uButtonState(2);
							return;
						}
						else if(portStatus == 0){
							addLogText("Trying create p2p connection...");
							retryCount++;
							if(retryCount>10){
								addLogText("create p2p connection timeout!");
								break;
							}
						}
						else if(portStatus == -2){
							addLogText("Create p2p connection failed!");
							break;
						}
						else if(portStatus == -3){
							addLogText("P2P connection interrupted!");
							break;
						}
						else if(portStatus == -4){
							addLogText("The device is offline!");
							break;
						}
						else if(portStatus == -5){
							addLogText("Password incorrect!");
							break;
						}
						SystemClock.sleep(1000);
					}
					if (p2pPort>0)
						T2u.DelPort((char)p2pPort);
					T2u.Exit();
					setT2uButtonState(0);
				}
			}
		});
		createThread.start();

	}

	private void closeP2PTunnel(){
		if (p2pPort>0)
			T2u.DelPort((char)p2pPort);
		T2u.Exit();
		addLogText("close P2P Tunnel success.");
		setT2uButtonState(0);
	}

	private void setT2uButtonState(final int state){
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				switch (state){
					case 0:
						if(checkPortStateTimer!=null){
							checkPortStateTimer.cancel();
							checkPortStateTimer = null;
						}
						test_local.setVisibility(View.GONE);
						t2u_button.setClickable(true);
						t2u_button.setText("Create P2P Tunnel!");
						t2u_button.setBackgroundColor(getResources().getColor(android.R.color.holo_blue_light));
						break;
					case 1:
						test_local.setVisibility(View.GONE);
						t2u_button.setClickable(false);
						t2u_button.setText("Creating ...");
						t2u_button.setBackgroundColor(getResources().getColor(android.R.color.darker_gray));
						break;
					case 2:
						test_local.setVisibility(View.VISIBLE);
						t2u_button.setClickable(true);
						t2u_button.setText("Close P2P Tunnel!");
						t2u_button.setBackgroundColor(getResources().getColor(android.R.color.holo_red_light));
						//start check portstate
						if(checkPortStateTimer==null){
							checkPortStateTimer = new Timer();
							checkPortStateTimer.schedule(new TimerTask() {
								@Override
								public void run() {
									int portStatus = T2u.PortStatus((char) p2pPort);
									if(curPortState!=portStatus){
										curPortState = portStatus;
										String textString = "PortStatus->:" + portStatus;
										addLogText(textString);
										if (portStatus==1){
											addLogText("create P2P Tunnel success.");
										}
										else if(portStatus == 0){
											addLogText("Trying create p2p connection...");
										}
										else if(portStatus == -2){
											addLogText("Create p2p connection failed!");
										}
										else if(portStatus == -3){
											addLogText("P2P connection interrupted!");
										}
										else if(portStatus == -4){
											addLogText("The device is offline!");
										}
										else if(portStatus == -5){
											addLogText("Password incorrect!");
										}
									}
								}
							},0,1000);
						}
						break;
				}
			}
		});
	}

	private void addLogText(final String text){
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				String textString = logText.getText().toString();
				SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//设置日期格式
				String curString = df.format(new Date())+":"+text+"\r\n";
				textString = curString+textString;
				logText.setText(textString);
			}
		});
	}
	protected void onDestroy()
	{
		if (p2pPort>0)
			T2u.DelPort((char)p2pPort);
		T2u.Exit();
		super.onDestroy();
	}
}
